<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Name Table</TITLE>
<link href="suifmath_18.html" rel=Next>
<link href="suifmath_16.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_16.html">previous</A>, <A HREF="suifmath_18.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC17" HREF="suifmath_toc.html#TOC17">Name Table</A></H2>
<P>
<A NAME="IDX370"></A>

</P>
<P>
A name table (class <CODE>name_table</CODE>) is a list of name table entries.
The first element of the name table always represents the constant value,
and thus there is no name associated with it.
<A NAME="IDX371"></A>

</P>

<P>
The following are functions and operations available for
<CODE>name_table</CODE>.  
In this list of functions, 
the symbols <CODE>nt</CODE>, <CODE>nt1</CODE> and <CODE>nt2</CODE> are of the class
<CODE>name_table</CODE>, the symbol <CODE>nte</CODE> is a <CODE>name_table_entry</CODE>, 
<CODE>i</CODE> and <CODE>j</CODE> are integers and 
<CODE>im1</CODE>, <CODE>im2</CODE> ... <CODE>im16</CODE> are <CODE>immed</CODE>s. 

</P>
<DL COMPACT>

<DT><CODE>name_table nt();</CODE>
<DD>
<DT><CODE>nt.init();</CODE>
<DD>
Initializes an empty name table.
<A NAME="IDX372"></A>
<A NAME="IDX373"></A>

<DT><CODE>name_table nt(nt1);</CODE>
<DD>
<DT><CODE>nt.init(nt1);</CODE>
<DD>
Create a duplicate copy of <CODE>nt1</CODE>.
<A NAME="IDX374"></A>
<A NAME="IDX375"></A>

<DT><CODE>name_table nt(im1);</CODE>
<DD>
<DT><CODE>name_table nt(im1, im2);</CODE>
<DD>
<DT><CODE>....</CODE>
<DD>
<DT><CODE>name_table nt(im1, im2, ..., im16);</CODE>
<DD>
Create a name table where <STRONG>1</STRONG> to <STRONG>n</STRONG> entries are the names
given in <CODE>im</CODE><STRONG>1</STRONG> to <CODE>im</CODE><STRONG>n</STRONG>.
<A NAME="IDX376"></A>

<DT><CODE>name_table nt(i);</CODE>
<DD>
<DT><CODE>nt.init(i);</CODE>
<DD>
Create a name table with <STRONG>i</STRONG> entries.
<A NAME="IDX377"></A>
<A NAME="IDX378"></A>

<DT><CODE>i = nt.n();</CODE>
<DD>
<STRONG>i</STRONG> is the number of entries of the name table <CODE> i &#62; 0 </CODE>.
<A NAME="IDX379"></A>

<DT><CODE>nte = nt[i];</CODE>
<DD>
Return the <STRONG>i</STRONG>th entry of the name table, given that <CODE> 0 &#60; i &#60;
nt.n() </CODE>.
<A NAME="IDX380"></A>

<DT><CODE>i = nt.find(nte);</CODE>
<DD>
<DT><CODE>i = nt.find(im1);</CODE>
<DD>
Find the position of the name <STRONG>nte</STRONG> (or <CODE>im1</CODE>) in the name
table.  If the name is not in the name table <STRONG>i</STRONG> <CODE>find()</CODE> will
return -1.
<A NAME="IDX381"></A>
<A NAME="IDX382"></A>

<DT><CODE>nt.remove(i);</CODE>
<DD>
<DT><CODE>nt.remove(i, j);</CODE>
<DD>
Remove the <STRONG>i</STRONG>th entry (or entries <STRONG>i</STRONG> through <STRONG>j</STRONG>) from the
name table.
<A NAME="IDX383"></A>
<A NAME="IDX384"></A>

<DT><CODE>nt.insert(nte, i);</CODE>
<DD>
<DT><CODE>nt.insert(im1, i);</CODE>
<DD>
Insert the name <STRONG>nte</STRONG> (or <STRONG>im1</STRONG>) at the <STRONG>i</STRONG>th postion of the
name table.
<A NAME="IDX385"></A>
<A NAME="IDX386"></A>

<DT><CODE>nt = nt1 &#38; nt2;</CODE>
<DD>
<DT><CODE>nt = name_table::mk_align(nt1, nt2);</CODE>
<DD>
Align the two name tables to produce a single name table.  <STRONG>nt</STRONG> has
an entry for all the variables in <STRONG>nt1</STRONG> and <STRONG>nt2</STRONG>.  For
identical names in <STRONG>nt1</STRONG> and <STRONG>nt2</STRONG>, there will be only a single
entry in <STRONG>nt</STRONG>.
<A NAME="IDX387"></A>
<A NAME="IDX388"></A>

<DT><CODE>boolean b = name_table::is_aligned(nt1, nt2);</CODE>
<DD>
Returns TRUE if <STRONG>nt1</STRONG> and <STRONG>nt2</STRONG> are already aligned.
<A NAME="IDX389"></A>

<DT><CODE>FILE * fp;</CODE>
<DD>
<DT><CODE>nt.print(fp);</CODE>
<DD>
Print the name table.
<A NAME="IDX390"></A>

</DL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_16.html">previous</A>, <A HREF="suifmath_18.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
